//import spawn
let Kore = require("@kirinnee/core").Kore;
let spawn = require('child_process').spawn;

let core = new Kore();
core.ExtendPrimitives();

//get first
let watch = process.argv.filter(s => s === '-w').length + process.argv.filter(s => s === "--watch").length > 0;
let command = process.argv[2];
let a = process.argv.Skip(3);

execute(command).then();

async function execute(command) {
    if (command === 'wp' || command === 'webpack') {
        let wbc = `webpack --config ./config/${a[0]}.ts --color`;
        if (watch) wbc += ' --watch';
        await run(wbc);
    } else if (command === 'unit' || command === 'test') {
        let mocha = `mocha -r ts-node/register ./test/**/*.spec.ts`;
        if (watch) mocha += ' --watch-extensions ts --watch';
        await run(mocha);
    } else if (command === 'pub') {
        let publish1 = `npm run build`;
        let publish2 = `git add .`;
        let publish3 = `git commit -m "Preparing for next ${a[0]} version`;
        let publish4 = `npm version ${a[0]}`;
        let publish5 = `npm publish`;
        try {
            await run(publish1);
            await run(publish2);
            await run(publish3);
            await run(publish4);
            await run(publish5);
        } catch (e) {
            console.log(e.message);
            process.exit(1);
        }
    } else {
        throw new Error('Unknown command type');
    }
}

async function run(command) {
    if (!Array.isArray(command) && typeof command === "string") command = command.split(' ');
    else throw new Error("command is either a string or a string array");
    let c = command.shift();
    let v = command;
    return new Promise((resolve, reject) => spawn(c, v, {stdio: "inherit", shell: true})
        .on("exit", (code,signal) => {
            if (code === 0) resolve();
            else reject(new Error("External command went wrong: "+signal));
        })
    );
}
